diff --git a/samples/bluetooth/peripheral_csc/src/main.c b/samples/bluetooth/peripheral_csc/src/main.c
index d3e7f29901..0c126d87e2 100644
--- a/samples/bluetooth/peripheral_csc/src/main.c
+++ b/samples/bluetooth/peripheral_csc/src/main.c
@@ -82,6 +82,7 @@ static uint8_t supported_locations[] = CSC_SUPPORTED_LOCATIONS;
 static uint8_t sensor_location; /* Current Sensor Location */
 static bool csc_simulate;
 static bool ctrl_point_configured;
+struct k_work work;
 
 static void csc_meas_ccc_cfg_changed(const struct bt_gatt_attr *attr,
 				     uint16_t value)
@@ -396,10 +397,17 @@ static void bas_notify(void)
 	bt_bas_set_battery_level(battery_level);
 }
 
+void csc_simulate_deferred(struct k_work *item)
+{
+	csc_simulation();
+}
+
 void main(void)
 {
 	int err;
 
+	k_work_init(&work, csc_simulate_deferred);
+
 	err = bt_enable(NULL);
 	if (err) {
 		printk("Bluetooth init failed (err %d)\n", err);
@@ -413,7 +421,7 @@ void main(void)
 
 		/* CSC simulation */
 		if (csc_simulate) {
-			csc_simulation();
+			k_work_submit(&work);
 		}
 
 		/* Battery level simulation */
